# $Revision: 1.36 $, $Date: 2011/08/18 14:37:28 $
# TODO
# - system lua-lfs for tests (LuaFileSystem 1.2)
# - daemon does not close its std fds
# - with keepalive=yes (angel mode) killing child with TERM sometimes does
#   nothing and your restart has to send SIGKILL eventually, seems it's just
#   losing the signal (some race?).
#   clock_gettime(CLOCK_MONOTONIC, {8381139, 777478778}) = 0
#   epoll_wait(6, {}, 8191, 962)            = 0
#   clock_gettime(CLOCK_MONOTONIC, {8381140, 739212126}) = 0
#   epoll_wait(6, {}, 8191, 1000)           = 0
#   clock_gettime(CLOCK_MONOTONIC, {8381141, 742484533}) = 0
#   - child TERM seems broken in non-angel mode as well (just loses it).
#   - child HUP seems broken in non-angel mode as well (sees it only once).
# - tests need fixing (can't find libs it built)
# OLD TODO
# - rw splitting bug: http://bugs.mysql.com/bug.php?id=36505
#   http://jan.kneschke.de/2007/8/26/mysql-proxy-more-r-w-splitting
#   http://www.teonator.net/2008/11/25/drupal-read-write-splitting/
#   http://dailyvim.blogspot.com/2008/07/mysql-high-availability-sandbox-proxy.html
#   https://launchpad.net/mysql-sandbox
# - move LUA_PATH to %{_datadir} chassis_frontend_get_default_lua_path()
#
# Conditional build:
%bcond_with	tests		# build with tests. needs mysql server on localhost:3306

Summary:	MySQL Proxy
Summary(pl.UTF-8):	Proxy MySQL
Name:		mysql-proxy
Version:	0.8.2
Release:	1
License:	GPL v2
Group:		Applications/Networking
Source0:	ftp://mysql.mirror.kangaroot.net/pub/mysql/Downloads/MySQL-Proxy/%{name}-%{version}.tar.gz
# Source0-md5:	b00784ddc5d28787fc99712d602a3614
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	%{name}.conf
Source4:	admin-1.lua
Patch0:		install-examples.patch
URL:		http://forge.mysql.com/wiki/MySQL_Proxy
BuildRequires:	autoconf >= 2.62
BuildRequires:	automake
BuildRequires:	glib2-devel >= 1:2.4.0
BuildRequires:	libevent-devel
BuildRequires:	libtool
BuildRequires:	lua51-devel
BuildRequires:	mysql-devel
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	sed >= 4.0
%if %{with tests}
BuildRequires:	check
BuildRequires:	lua51
%endif
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	rc-scripts >= 0.4.2.8
Provides:	group(mysqlproxy)
Provides:	user(mysqlproxy)
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_includedir	%{_prefix}/include/%{name}

%description
MySQL Proxy is a simple program that sits between your client and
MySQL server(s) that can monitor, analyze or transform their
communication. Its flexibility allows for unlimited uses; common ones
include: load balancing; failover; query analysis; query filtering and
modification; and many more.

%description -l pl.UTF-8
MySQL Proxy to prosty program tkwiący między klienten a
serwerem/serwerami MySQL, potrafiący monitorować, analizować i
przekształcać ich komunikację. Jego elastyczność pozwala na
nieograniczone wykorzystanie; popularne sposoby użycia obejmują: load
balancing, failover, analizę zapytań, filtrowanie i modyfikowanie
zapytań... i wiele więcej.

%prep
%setup -q
%patch0 -p1

%{__sed} -i -e 's/g_build_filename(base_dir, "lib"/g_build_filename(base_dir, "%{_lib}"/g' src/chassis-frontend.c
%{__sed} -i -e 's/g_build_filename(srv->base_dir, "lib"/g_build_filename(srv->base_dir, "%{_lib}"/g' src/chassis-frontend.c

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	--with-lua=lua51
%{__make}

%if %{with tests}
export MYSQL_USER=mysql
export MYSQL_PASSWORD=
export MYSQL_HOST=localhost
export MYSQL_DB=test
%{__make} -C tests/suite check
%endif

%install
rm -rf $RPM_BUILD_ROOT
%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{/etc/{rc.d/init.d,sysconfig},%{_sysconfdir}/%{name},/var/log/{archive,}/%{name}}
install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
cp -a %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/%{name}
cp -a %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/%{name}/%{name}.conf

# daemon in sbindir
install -d $RPM_BUILD_ROOT%{_sbindir}
mv $RPM_BUILD_ROOT{%{_bindir},%{_sbindir}}/mysql-proxy

# noarch data to %{_datadir}
install -d $RPM_BUILD_ROOT%{_datadir}/%{name}/lua
mv $RPM_BUILD_ROOT{%{_libdir},%{_datadir}}/%{name}/lua/proxy
mv $RPM_BUILD_ROOT{%{_libdir},%{_datadir}}/%{name}/lua/examples
mv $RPM_BUILD_ROOT{%{_libdir},%{_datadir}}/%{name}/lua/admin.lua
# contrib lua
cp -a %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/%{name}/lua/proxy

rm -f $RPM_BUILD_ROOT%{_libdir}/%{name}/plugins/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/%{name}/lua/*.la

# no -devel, kill
rm -rf $RPM_BUILD_ROOT%{_includedir}
rm -rf $RPM_BUILD_ROOT%{_libdir}/libmysql-*.la
rm -rf $RPM_BUILD_ROOT%{_libdir}/libmysql-*.so
rm -rf $RPM_BUILD_ROOT%{_pkgconfigdir}

# put those to -tutorial package
rm -f $RPM_BUILD_ROOT%{_datadir}/*.lua

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 193 mysqlproxy
%useradd -u 193 -g mysqlproxy -c "MySQL Proxy" mysqlproxy

%post
/sbin/ldconfig
/sbin/chkconfig --add %{name}
%service %{name} restart "MySQL Proxy"

%preun
if [ "$1" = "0" ]; then
	%service -q %{name} stop
	/sbin/chkconfig --del %{name}
fi

%postun
/sbin/ldconfig
if [ "$1" = "0" ]; then
	%userremove mysqlproxy
	%groupremove mysqlproxy
fi

%files
%defattr(644,root,root,755)
%doc AUTHORS NEWS README* ChangeLog
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%dir %attr(750,root,root) %{_sysconfdir}/%{name}
%config(noreplace) %attr(640,root,root) %verify(not md5 mtime size) %{_sysconfdir}/%{name}/%{name}.conf
%attr(755,root,root) %{_sbindir}/%{name}

%attr(750,root,mysqlproxy) %dir /var/log/%{name}
%attr(750,root,mysqlproxy) %dir /var/log/archive/%{name}

# ??? tools?
%attr(755,root,root) %{_bindir}/mysql-binlog-dump
%attr(755,root,root) %{_bindir}/mysql-myisam-dump

%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/lua
%attr(755,root,root) %{_libdir}/%{name}/lua/chassis.so
%attr(755,root,root) %{_libdir}/%{name}/lua/glib2.so
%attr(755,root,root) %{_libdir}/%{name}/lua/lfs.so
%attr(755,root,root) %{_libdir}/%{name}/lua/lpeg.so
%attr(755,root,root) %{_libdir}/%{name}/lua/mysql.so
%attr(755,root,root) %{_libdir}/%{name}/lua/posix.so

%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/lua
%{_datadir}/%{name}/lua/admin.lua
%dir %{_datadir}/%{name}/lua/proxy
%{_datadir}/%{name}/lua/proxy/*.lua
%dir %{_datadir}/%{name}/lua/examples
%{_datadir}/%{name}/lua/examples/*.lua
%{_datadir}/%{name}/lua/examples/*.msc

%dir %{_libdir}/%{name}/plugins
%attr(755,root,root) %{_libdir}/%{name}/plugins/libadmin.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/libdebug.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/libproxy.so
%attr(755,root,root) %{_libdir}/%{name}/plugins/libreplicant.so

# -libs
%attr(755,root,root) %ghost %{_libdir}/libmysql-chassis-timing.so.0
%attr(755,root,root) %{_libdir}/libmysql-chassis-timing.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libmysql-chassis.so.0
%attr(755,root,root) %{_libdir}/libmysql-chassis.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libmysql-chassis-glibext.so.0
%attr(755,root,root) %{_libdir}/libmysql-chassis-glibext.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libmysql-proxy.so.0
%attr(755,root,root) %{_libdir}/libmysql-proxy.so.*.*.*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: mysql-proxy.spec,v $
Revision 1.36  2011/08/18 14:37:28  glen
- up to 0.8.2

Revision 1.35  2011/02/25 16:28:48  arekm
- rel 1

Revision 1.34  2010/09/17 13:04:50  glen
- fix admin.lua install
- license version

Revision 1.33  2010/09/17 12:59:47  glen
- 0.8.1

Revision 1.32  2010/08/04 13:15:21  glen
- install example lua

Revision 1.31  2010/05/21 14:27:50  glen
- release 2

Revision 1.30  2010/05/21 14:27:31  glen
- release 1

Revision 1.29  2010/05/21 14:27:21  glen
- add custom admin-1.lua

Revision 1.28  2010/05/17 18:49:57  glen
- release 0.16

Revision 1.27  2010/05/17 18:24:08  glen
- handle angel mode in initscript, but seems there is something very wrong and broken in the code with signals

Revision 1.26  2010/05/17 17:37:35  glen
- redirfds is back, problem with angel process

Revision 1.25  2010/05/17 17:20:38  glen
- drop devel files
- move .lua to /usr/share

Revision 1.24  2010/05/17 17:09:07  glen
- add log dirs

Revision 1.23  2010/05/17 16:14:37  glen
- add defaults file

Revision 1.22  2010/05/17 14:07:27  glen
- no need for own run dir as daemonizing done by daemon itself

Revision 1.21  2010/05/17 13:43:31  glen
- lib64 fix

Revision 1.20  2010/05/16 14:50:02  sparky
- BR: pkgconfig

Revision 1.19  2010/05/04 10:38:08  glen
- todo and cleanups

Revision 1.18  2010/04/14 11:18:47  glen
- --closefds needed due daemon not doing it

Revision 1.17  2010/04/14 11:07:29  glen
- up to 0.8.0, do we want -devel?

Revision 1.16  2008/11/16 18:29:58  glen
- release 3

Revision 1.15  2008/11/10 23:23:37  glen
- release 2

Revision 1.14  2008/10/29 22:24:44  glen
- official 0.6.1 tarball

Revision 1.13  2007-12-11 10:25:04  glen
- exported from 0.6.1 tag

Revision 1.12  2007-12-10 14:43:01  glen
- rel 2

Revision 1.11  2007-12-10 11:32:30  glen
- add mysqlproxy user/group; rel 1

Revision 1.10  2007-11-21 23:29:32  glen
- add initscript

Revision 1.9  2007-11-21 22:43:47  glen
- tests pass if requirements made

Revision 1.8  2007-11-21 22:24:43  glen
- autoregen works now

Revision 1.7  2007-11-21 10:22:04  glen
- add tests, lua patch
- am regen fails

Revision 1.6  2007-11-21 09:51:19  glen
- update to 0.6.0

Revision 1.5  2007-07-07 00:12:15  qboosh
- pl

Revision 1.4  2007/06/26 18:52:34  glen
- BR: glib2-devel

Revision 1.3  2007/06/26 18:47:09  glen
- BR: mysql-devel

Revision 1.2  2007/06/26 18:46:01  glen
- BR: libevent-devel

Revision 1.1  2007/06/26 07:24:02  glen
- new
